package cyan.lang;
import cyanruntime.*;


    /**
    A dynamic tuple. Given a variable 't' of this prototype, 't ?name: v' adds 'name'
    with value 'v' to a list. When 't' receives a message 'name', as in 't ?name',
    value 'v' is returned. 
        It is best to declare a variable that refer to a DTuple object with type Dyn. 
    The adding and retrieving of values becomes more clean:
          let Dyn t = DTuple();
          t name: "Carolina";
          t name println;
    */

@SuppressWarnings( { "unused", "cast", "hiding" } )
public final class _DTuple extends _Any
 {

	private static final long serialVersionUID = 7914141492442842395L;
    static { 
        try {

          _DTuple.prototype = new _DTuple();
        }
        catch ( ExceptionInInitializerError e ) {
            System.out.println("Probably this prototype is referenced indirectly in a method called " + 
"in its 'init' method. This " + 
"happens in this example:\n" + 
"    object InitError\n" + 
"        func init { \n" + 
"            MakeError accessInitError;\n" + 
"        }\n" + 
"    end\n" + 
"Method 'accessInitError' is just\n" + 
"    func accessInitError { \n" + 
"        InitError prototypeName println; \n" + 
"    }\n" + 
"Then InitError is referenced before the 'init' " + 
"method has built the object that represents the " + 
"prototype"); 
       }

    }
        /**
    A dynamic tuple. Given a variable 't' of this prototype, 't ?name: v' adds 'name'
    with value 'v' to a list. When 't' receives a message 'name', as in 't ?name',
    value 'v' is returned. 
        It is best to declare a variable that refer to a DTuple object with type Dyn. 
    The adding and retrieving of values becomes more clean:
          let Dyn t = DTuple();
          t name: "Carolina";
          t name println;
    */
    private     cyan.lang._Array_LT_GP_CyString_GT _fieldList;
    private     cyan.lang._Array_LT_GP_Object_GT _valueList;

    public     _DTuple() {

        /* fieldList = Array<String> new */
        _Array_LT_GP_CyString_GT tmp1877 = new _Array_LT_GP_CyString_GT();
        _fieldList = tmp1877;
        /* valueList = Array<Dyn> new */
        _Array_LT_GP_Object_GT tmp1878 = new _Array_LT_GP_Object_GT();
        _valueList = tmp1878;
        } 

    public _DTuple _new() {
         
            return new _DTuple();         
        } 
        /**
        if 'methodName' is the name of a unary method, the field should have already 
        been added to the tuple. If not, a runtime error occurs. The value associated
        to the unary method is returned. If 'methodName' is a method with just one
        parameter, the value associated to the method name is returned. If 'args' 
        has more than one parameter
        */

    public @Override Object  _doesNotUnderstand_2( CyString _methodName, _Array_LT_GP__Array_LT_GP_Object_GT_GT _args )  {
        CyInt tmp1880 = _args._size();
        CyBoolean tmp1881 = tmp1880._equal_equal( CyInt.one);
        CyBoolean tmp1879;
        if ( ! tmp1881.b ) { 
            CyInt tmp1882 = _methodName._countChar_1( (new CyChar(':')));
            CyBoolean tmp1883 = tmp1882._greaterThan( CyInt.one);
            tmp1879 = new CyBoolean(tmp1883.b );
        }
        else {
            tmp1879 = new CyBoolean(true);
        }
        if ( tmp1879.b ) {
            _Array_LT_GP_Object_GT tmp1884;
            tmp1884 = _args._at_1(CyInt.zero);

            _Array_LT_GP_Object_GT _dynList;
            _dynList = tmp1884;
            CyInt tmp1885 = _dynList._size();
            CyBoolean tmp1886 = tmp1885._equal_equal( CyInt.zero);
            if ( tmp1886.b ) {

                CyInt _i;
                _i = CyInt.zero;
                    {
                    CyString _fieldName;
                    _Iterator_LT_GP_CyString_GT tmp1887 = _fieldList._iterator();
                    while ( tmp1887._hasNext().b ) { 
                        _fieldName = tmp1887._next();
                        CyBoolean tmp1888 = _fieldName._equal_equal( _methodName);
                        if ( tmp1888.b ) {
                            Object tmp1889;
                            tmp1889 = _valueList._at_1(_i);

                            return tmp1889;
                        }
                        // end of if
                        _i = _i._succ();
                    }
                }
            }
            else {
                CyInt tmp1890 = _dynList._size();
                CyBoolean tmp1891 = tmp1890._equal_equal( CyInt.one);
                if ( tmp1891.b ) {

                    CyInt _j;
                    _j = CyInt.zero;
                    CyInt tmp1893 = _methodName._size();
                    CyInt tmp1894 = tmp1893._minus( CyInt.one);
                    CyString tmp1892 = _methodName._substring_2( CyInt.zero, tmp1894);

                    CyString _newMethodName;
                    _newMethodName = tmp1892;
                        {
                        CyString _fieldName;
                        _Iterator_LT_GP_CyString_GT tmp1895 = _fieldList._iterator();
                        while ( tmp1895._hasNext().b ) { 
                            _fieldName = tmp1895._next();
                            CyBoolean tmp1896 = _fieldName._equal_equal( _newMethodName);
                            if ( tmp1896.b ) {
                                /* valueList[j] = dynList[0] */
                                Object tmp1897;
                                tmp1897 = _dynList._at_1(CyInt.zero);
                                if ( !(tmp1897 instanceof Object ) ) 
                                    throw new ExceptionContainer__(new _ExceptionCast( new CyString("Cannot cast expression 'dynList[0]' to 'Dyn' in line 51 of file DTuple.cyan") ) );
                                _valueList._at_1_put_1(_j, ((Object ) tmp1897));
                                Object tmp1898;
                                tmp1898 = _dynList._at_1(CyInt.zero);

                                return tmp1898;
                            }
                            // end of if
                            _j = _j._succ();
                        }
                    }
                    CyInt tmp1901 = _methodName._size();
                    CyInt tmp1902 = tmp1901._minus( CyInt.one);
                    CyString tmp1900 = _methodName._substring_2( CyInt.zero, tmp1902);
                    _Nil tmp1899 = _fieldList._add_1( tmp1900);
                    Object tmp1904;
                    tmp1904 = _dynList._at_1(CyInt.zero);
                    _Nil tmp1903 = _valueList._add_1( tmp1904);
                    Object tmp1905;
                    tmp1905 = _dynList._at_1(CyInt.zero);

                    return tmp1905;
                }
            }
            // end of if
        }
        // end of if
        CyString tmp1908 = this._prototypeName();
        CyString tmp1907 = (new CyString("Method " + _methodName._asString().s + " was not found in object of prototype"))._plus_plus( tmp1908);
        _Nil tmp1906 = tmp1907._println();

        return _Nil.prototype;
        } 

    public CyBoolean  _contains_1( CyString _fieldName )  {
        CyBoolean tmp1909 = _fieldList._contains_1( _fieldName);

        return tmp1909;
        } 

    public CyInt _size() {
        CyInt tmp1910 = _fieldList._size();
        return tmp1910;
        } 

    public _Array_LT_GP_CyString_GT _getFieldList() {
        return _fieldList;
        } 

    public @Override _DTuple _prototype() {
         return prototype;
        
        } 

    public @Override _DTuple _clone() {
        
        try {
            return (_DTuple ) this.clone(); 
        } catch (CloneNotSupportedException e) { }
        return null;
        
        } 

    public @Override _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _getFeatureListNameDoesNotCollide____() {
        _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT tmp1911 = new _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT();

        return tmp1911;
        } 

    public @Override _Array_LT_GP__Any_GT _getAnnotListNameDoesNotCollide____() {
        _Array_LT_GP__Any_GT tmp1912 = new _Array_LT_GP__Any_GT();

        return tmp1912;
        } 

    public @Override _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _getSlotFeatureListNameDoesNotCollide____() {
        _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT tmp1913 = new _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT();

        _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _slotFeatureList__name__does__not__collide____;
        _slotFeatureList__name__does__not__collide____ = tmp1913;

        return _slotFeatureList__name__does__not__collide____;
        } 
    public static _DTuple prototype;

    static final String []fieldList = { "fieldList", "valueList" };
    static final String []fieldTypeList = { "cyan.lang.Array<String>", "cyan.lang.Array<Dyn>" };
    public static _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT featureList = new _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT();
    public static _Array_LT_GP__Any_GT annotList = new _Array_LT_GP__Any_GT();

    static final _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT slotFeatureList = new _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT();
    static CyString []methodNameList = { 
        new CyString("doesNotUnderstand: String, Array<Array<Dyn>> -> Dyn"),
        new CyString("contains: String -> Boolean"),
        new CyString("size -> Int"),
        new CyString("getFieldList -> Array<String>"),
        new CyString("prototype -> DTuple"),
        new CyString("clone -> DTuple"),
        new CyString("getFeatureListNameDoesNotCollide__ -> Array<Tuple<key,String,value,Any>>"),
        new CyString("getAnnotListNameDoesNotCollide__ -> Array<Any>"),
        new CyString("getSlotFeatureListNameDoesNotCollide__ -> Array<Tuple<slotName,String,key,String,value,Any>>")
        };
    @Override protected CyString [] getMethodNameList2() { return methodNameList; }
    @Override protected String [] getFieldList2() { return fieldList; }

    private CyBoolean _eq_1_super__( Object p0 ) { return super._eq_1( p0 ); }
    private CyBoolean _neq_1_super__( Object p0 ) { return super._neq_1( p0 ); }
    private _Any _prototype_super__() { return super._prototype(); }
    private CyString _prototypeName_super__() { return super._prototypeName(); }
    private _Any _prototypeParent_super__() { return super._prototypeParent(); }
    private CyString _prototypePackageName_super__() { return super._prototypePackageName(); }
    private CyBoolean _isInterface_super__() { return super._isInterface(); }
    private CyBoolean _isA_1_super__( _Any p0 ) { return super._isA_1( p0 ); }
    private CyBoolean _notIsA_1_super__( _Any p0 ) { return super._notIsA_1( p0 ); }
    private Object _throw_1_super__( _CyException p0 ) { return super._throw_1( p0 ); }
    private _Any _clone_super__() { return super._clone(); }
    private CyString _plus_plus_super__(_Any _other) { return super._plus_plus(_other); }
    private CyString _asString_super__() { return super._asString(); }
    private CyString _asString_1_super__( CyInt p0 ) { return super._asString_1( p0 ); }
    private CyString _asStringThisOnly_1_super__( CyInt p0 ) { return super._asStringThisOnly_1( p0 ); }
    private CyString _asStringQuoteIfString_super__() { return super._asStringQuoteIfString(); }
    private CyBoolean _equal_equal_super__(Object _other) { return super._equal_equal(_other); }
    private CyBoolean _equal_equal_equal_super__(Object _other) { return super._equal_equal_equal(_other); }
    private CyBoolean _exclamation_equal_equal_super__(Object _other) { return super._exclamation_equal_equal(_other); }
    private CyBoolean _exclamation_equal_super__(Object _other) { return super._exclamation_equal(_other); }
    private CyBoolean _isCase_1_super__( _Any p0 ) { return super._isCase_1( p0 ); }
    private _Nil _assertxx_1_super__( CyBoolean p0 ) { return super._assertxx_1( p0 ); }
    private _Nil _assertxx_2_super__( CyBoolean p0, CyString p1 ) { return super._assertxx_2( p0, p1 ); }
    private _Nil _print_super__() { return super._print(); }
    private _Nil _println_super__() { return super._println(); }
    private _Nil _printspc_super__() { return super._printspc(); }
    private _Nil _printc_super__() { return super._printc(); }
    private _Any _toAny_1_super__( Object p0 ) { return super._toAny_1( p0 ); }
    private _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _featureList_super__() { return super._featureList(); }
    private _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _featureList_1_super__( CyString p0 ) { return super._featureList_1( p0 ); }
    private _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _slotFeatureList_super__() { return super._slotFeatureList(); }
    private _Array_LT_GP__Any_GT _annotList_super__() { return super._annotList(); }
    private _Array_LT_GP__Any_GT _annotList_1_super__( CyString p0 ) { return super._annotList_1( p0 ); }
    private Object _doesNotUnderstand_2_super__( CyString p0, _Array_LT_GP__Array_LT_GP_Object_GT_GT p1 ) { return super._doesNotUnderstand_2( p0, p1 ); }
    private _Any _functionForMethod_1_super__( CyString p0 ) { return super._functionForMethod_1( p0 ); }
    private _Any _functionForMethodWithSelf_1_super__( CyString p0 ) { return super._functionForMethodWithSelf_1( p0 ); }
    private CyInt _hashCode_super__() { return super._hashCode(); }
    private _Array_LT_GP_CyString_GT _getMethodNameList_super__() { return super._getMethodNameList(); }
    private _Array_LT_GP_CyString_GT _getFieldNameList_super__() { return super._getFieldNameList(); }
    private _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _getFeatureListNameDoesNotCollide_____super__() { return super._getFeatureListNameDoesNotCollide____(); }
    private _Array_LT_GP__Any_GT _getAnnotListNameDoesNotCollide_____super__() { return super._getAnnotListNameDoesNotCollide____(); }
    private _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT _getSlotFeatureListNameDoesNotCollide_____super__() { return super._getSlotFeatureListNameDoesNotCollide____(); }
    public String []getFieldTypeList() { 
        return fieldTypeList;
    }
    public String []getFieldList() { 
        return fieldList;
    }
    public String asString(int ident) {
        String s =  "DTuple {\n";
        s = s + "super(Any):"  + super.asStringThisOnly( ident + _Any.defaultIdentNumber__ );
        s = s + asStringThisOnly( ident + _Any.defaultIdentNumber__);

        s = s + getWhiteSpaces(ident) + "}\n";
        return s;
    } 
    @Override 
    protected String asStringThisOnly(int ident) {
        String s = getWhiteSpaces(ident);
        s = s + getWhiteSpaces(ident) + "fieldList: " + _fieldList._asString().s + "\n";
        s = s + getWhiteSpaces(ident) + "valueList: " + _valueList._asString().s + "\n";
        return s;
    } 
    protected _Any parent() {
        return _Any.prototype;
    }
    protected CyString prototypePackage() {
        return new CyString( "cyan.lang" );
    }
    static final String prototypeName = "DTuple";
    @Override     public String getPrototypeName() { return prototypeName; }
    protected boolean isInterface() { return false; }

    @Override public _Array_LT_GP__Tuple_LT_GP__key_GP_CyString_GP__value_GP__Any_GT_GT getFeatureList() { return featureList; }
    @Override public _Array_LT_GP__Tuple_LT_GP__slotName_GP_CyString_GP__key_GP_CyString_GP__value_GP__Any_GT_GT getSlotFeatureList() { return slotFeatureList; }
    @Override public _Array_LT_GP__Any_GT getAnnotList() { return annotList; }
    static {
    }

}
